/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.Services;


import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import sk.tuke.fei.KpiEas.abstraktne.Premenne;

/**
 * trieda zabezpecujuca spacovanie nadialku cez web service
 *
 * @author S. Hovanec, S.Korecko
 */
@WebService(serviceName = "EvaluateAnswerWS")
public class EvaluateAnswerWS {

    /**
     * instancia aplikacie
     */
    private static sk.tuke.fei.KpiEas.abstraktne.Premenne main;
    /**
     * pocet spravne vyhodnotenych testov
     */
    private int spravne = 0;
    /**
     * premenna nahodnych prememnych
     */
    private Random random = new Random();
    private int skuska = 0;
    
    private int mode = 0;
    
    
    /**
     * komunikacia so servrom
     */
    /**
     * Metoda vyhodnoti odpoved studenta (program) Uspesnost je hodnotena podla
     * poctu uspesnych simulacii pasok, ktore su zadane v subore so spravnou
     * odpovedou.
     *
     * @param instrukcieStudenta - retazec s programom, ktory student napisal
     * ako odpoved.
     * @param kontrData - xml data obsahujuce nastavenie stroja a testy
     * @param mode - mod sluzby, ci sa len kontroluje syntax programu alebo sa cely vykonava
     * @return hodnotenie - od 0 do 100
     */
   
    @WebMethod(operationName = "evaluate")

    public String evaluate(@WebParam(name = "instrukcieStudenta") String instrukcieStudenta, @WebParam(name = "kontrData") String kontrData, @WebParam(name = "mode") int mode, @WebParam(name = "key") String key) {
        String aKey = MD5("modul_astraktne@");
        if (!aKey.equals(key))
        {
            return "Security error";
        }
        System.out.println("EVALUATE SERVICE STARTED.");                    //by SKor
        System.out.println("Test data:\n" + kontrData);                     //by SKor
        System.out.println("Student answer:\n" + instrukcieStudenta);       //by SKor
        main = new Premenne();
        main.program.setService(true);
        instrukcieStudenta = instrukcieStudenta.replace(";", "\n");
        //System.out.println("Student answer after modif.:\n" + instrukcieStudenta);    //by SKor
        
        //precita sa program z tvojho pc podla coho sa vykona kontrola
        main.cache.setProgram(instrukcieStudenta);
        
        this.mode = mode;
        
        try {
            main = readXml(main, kontrData);
        } catch (Exception e) {
            System.out.println("XML read error: " + e);
            return "zly vstupny subor" + e.toString();
        }
        System.out.println("Starting evaluation...");                       //by SKor
        serviceSim();  
        System.out.println("Evaluation completed.");                        //by SKor
        //tu by sa mal odovzdat string s insktruciami od studenta akontrolovat
        //nech vrati tato metoda premennu vysledok s float cislom
        System.out.println("Evaluation result: " + main.vysledok);          //by SKor

        return Integer.toString(main.vysledok);
    }

    /**
     * spustenie samotnej simulacie s vyhodnotenim
     */
    private void serviceSim() {
        //programTest();
        if (main.program.getTyp() == 1) {
            simSerTur();
        }
        if (main.program.getTyp() == 2) {
            simSerZas();
        }
        if (main.program.getTyp() == 3) {
            simSerKon();
        }
    }
     /**
     * Nacitanie dat z xml
     */
    private Premenne readXml(Premenne get, String data) {

        Premenne set = get;
        set.cache.getZazServ().clear();
        sk.tuke.fei.KpiEas.model.ZaznamService zaznam = null;
        
        try {
            List<String> list = new ArrayList<String>();
            Document xmlData = loadXMLFromString(data);
            xmlData.getDocumentElement().normalize();
            String machine = xmlData.getDocumentElement().getAttribute("machine");
            NodeList nList = xmlData.getElementsByTagName("test");
            int machineType = getMachine(machine);
            int aType = getMachineType(machineType, xmlData.getDocumentElement().getAttribute("type"));
            int numOfTests = nList.getLength();
            String initState = xmlData.getDocumentElement().getAttribute("init");
            String finalState = xmlData.getDocumentElement().getAttribute("final");
            String ln;
            if (machineType == 3) {
                ln = machineType + ";" + numOfTests + ";";
            } else {
                ln = machineType + ";" + numOfTests + ";" + aType + ";";
            }

            list = set.cache.delZnaky(ln, ";");
            set.program.setTyp(machineType);
            set.program.setPocetTestov(numOfTests);
            if (set.program.getTyp() == 2) {//zas.automat
                set.program.setMode(aType);
            } else if (set.program.getTyp() == 1) {//turing
                if (aType == 0) {
                    set.program.setViacPas(false);
                } else {
                    set.program.setViacPas(true);
                }
            }
            
            for (int temp = 0; temp < nList.getLength(); temp++) {
                Node nNode = nList.item(temp);
               // System.out.println("\nCurrent Element: " + nNode.getNodeName() + " #" + (int) (temp + 1));
                if (nNode.getNodeType() == Node.ELEMENT_NODE) {
                    
                    Element eElement = (Element) nNode;
                    int maxSteps = Integer.parseInt(eElement.getAttribute("maxsteps"));
                    Boolean accept = Boolean.parseBoolean(eElement.getAttribute("accept"));
                    int acceptState = 1;
                    if (accept == false) {
                        acceptState = 0;
                    }
                    String tape = eElement.getElementsByTagName("tape").item(0).getTextContent();
                   
                    zaznam = new sk.tuke.fei.KpiEas.model.ZaznamService();
                    ln = maxSteps + ";" + acceptState + ";" + initState + ";" + finalState + ";";
                    list = set.cache.delZnaky(ln, ";");
                    
                    zaznam.setPocRot(maxSteps); //pocet krokov
                    if (acceptState == 0) {
                        zaznam.setSimOk(false);
                    }
                    zaznam.setStartQ(initState);
                    zaznam.setKonQ(finalState);
                    zaznam.setPaska(tape);
                    if (set.program.getTyp() == 2) {//ak ide o zas. automat
                        NodeList el = eElement.getElementsByTagName("stack"); 
                        if (el.getLength() > 0) //existuje stack element ?
                        {
                            System.out.println("eee");
                            zaznam.setZasob(eElement.getElementsByTagName("stack").item(0).getTextContent());
                        } 
                    } 
                    set.cache.pridajZaznam(zaznam);
                }
            }
        } catch (Exception e) {
            System.out.println(e);
        }
        return set;
    }

   
    /**
     * nacitanie udajov zo suboru
     */
    private Premenne readProgram(Premenne get, String cesta, String subor) {

        Premenne set = get;
        set.cache.getZazServ().clear();
        sk.tuke.fei.KpiEas.model.ZaznamService zaznam = null;

        StringBuilder tmp = new StringBuilder(cesta);
        tmp.append(File.separator);
        tmp.append(subor);
        String plneMeno = tmp.toString();

        File file = new File(plneMeno);
        try {
            FileInputStream fstream = new FileInputStream(file);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));

            List<String> list;
            String line;

            int spLine = 0; //0-1. riadok (havicka); x, x>0 - x-ty riadok spcifikacie testu
            while ((line = br.readLine()) != null) {

                System.out.println(line + " [a=" + spLine + "]"); //by SKor

                if (spLine == 0) {
                    list = set.cache.delZnaky(line, ";");

                    System.out.println("list line1 =" + list.toString()); //by SKor

                    set.program.setTyp(Integer.parseInt(list.get(0)));
                    set.program.setPocetTestov(Integer.parseInt(list.get(1)));
                    if (set.program.getTyp() == 2) {//zas.automat
                        set.program.setMode(Integer.parseInt(list.get(2)));
                    } else if (set.program.getTyp() == 1) {//turing
                        if (Integer.parseInt(list.get(2)) == 0) {
                            set.program.setViacPas(false);
                        } else {
                            set.program.setViacPas(true);
                        }
                    }
                    spLine = 1;
                } else if (spLine == 1) {
                    zaznam = new sk.tuke.fei.KpiEas.model.ZaznamService();
                    list = set.cache.delZnaky(line, ";");
                    System.out.println("list test1 =" + list.toString()); //by SKor
                    zaznam.setPocRot(Integer.parseInt(list.get(0)));
                    if (Integer.parseInt(list.get(1)) == 0) {
                        zaznam.setSimOk(false);
                    }
                    zaznam.setStartQ(list.get(2));
                    zaznam.setKonQ(list.get(3));
                    spLine = 2;
                } else if (spLine == 2) {
                    zaznam.setPaska(line);
                    if (set.program.getTyp() == 2) {//ak ide o zas. automat
                        spLine = 3;//este ma test treti riadok so zasobnikom
                    } else {
                        spLine = 1;
                    }
                } else if (spLine == 3) {
                    zaznam.setZasob(line);
                    spLine = 1;
                }
                if (zaznam != null && spLine == 1) { //by SKor: pridana podmienka "a==1"
                    set.cache.pridajZaznam(zaznam);
                    System.out.println("[pridZaz]");//by SKor
                }
            }
            in.close();
        } catch (Exception e) {
            System.out.println(e);
        }

        System.out.println("Nacitane testy: " + main.cache.getZazServ().toString());//by SKor


        return set;
    }

    /**
     * kontrola programu pre zasobnikovy automat
     *
     * @return true pri spravnom programe
     */
    private Boolean konSerZas() {
        main.cache.setErrLine(null);
        main.program.getProgram().clear();
        main.paska.getPaska().clear();

        main.program.setPrerus(false);
        main.program.setVyberbool(false);

        List poz = new ArrayList();
        poz.add(0);
        poz.add(0);
        main.paska.setPozPasky(poz);

        if (main.cache.getProgram().isEmpty()) {
            return false;
        } else if (main.cache.getPaska().isEmpty()) {
            return false;
        } else if (main.cache.getPocStav().isEmpty() || main.cache.getPocStav().isEmpty()) {
            return false;
        } else {
            main.program.setZacStav(main.cache.getPocStav().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(main.cache.getKonStav().toString().trim(), ","));
            main = main.subor.kontrolaProgramu(main);


            if (main.kontrola) {
                return true;
            }
        }
        System.out.println("Program zly: " + main.cache.getErrLine());//by SKor
        return false;
    }

    /**
     * simulacia zasobnikoveho automatu
     */
    private void simSerZas() {
        main.vysledok = -1;
        spravne = 0;
        skuska = 0;
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();

        for (int a = 0; a < main.program.getPocetTestov(); a++) {
            main.rotacie = 0;
            main.cache.setPaska(main.cache.getZazServ().get(a).getPaska());
            main.cache.setZasobnik(main.cache.getZazServ().get(a).getZasob());
            main.cache.setPocStav(main.cache.getZazServ().get(a).getStartQ());
            main.cache.setKonStav(main.cache.getZazServ().get(a).getKonQ());

            System.out.println("[Test " + a + "] paska= " + main.cache.getPaska()
                    + " poc.stav=" + main.cache.getPocStav()
                    + " kon.stav=" + main.cache.getKonStav()); //by SKor

            if (konSerZas()) {
                if (mode == 1)
                {
                    main.vysledok = 100;
                    return;
                }
                System.out.println("Program ZA v poriadku");//by SKor

                skuska++;
                main = sim.simulaciaZasInit(main);
                while (sim.mozny) {
                    main = sim.simulaciaZasZhod(main);
                    int zhoda = main.program.getVyberI();
                    skuska++;
                    if (zhoda != -1) {
                        if (!main.program.getProgram().get(zhoda).getDupli().isEmpty()) {
                            main = sim.vyber(main, zhoda);
                            main.program.setVyberI(random());
                            zhoda = main.program.getVyberI();
                        }
                        main = sim.simulaciaZasSprac(main);
                    }
                    if (!sim.mozny) {
                        main = sim.simulaciaZasVyhod(main);
                        if (main.program.getSimOk() == main.cache.getZazServ().get(a).getSimOk()) {
                            spravne++;
                            skuska++;
                            System.out.println("  Stack Mch simulation:: test " + a + "  PASSED");                       //by SKor

                        }
                        break;
                    }

                    if (main.cache.getZazServ().get(a).getPocRot() < main.rotacie) {
                        break;
                    }
                    main.rotacie++;
                }
            }
        }

        main.vysledok = ((spravne * 100) / main.program.getPocetTestov());


    }

    /**
     * kontrola programu pre konecny automat
     *
     * @return true pri spravnom programe
     */
    private Boolean konSerKon() {
        main.cache.setErrLine(null);
        main.program.getProgram().clear();
        main.paska.getPaska().clear();

        main.program.setPrerus(false);
        main.program.setVyberbool(false);
        main.paska.getPozPasky().add(0);

        Boolean start = false;
        if (main.cache.getProgram().isEmpty()) {
            return false;
        } else if (main.cache.getPaska().isEmpty()) {
            return false;
        } else if (main.cache.getPocStav().isEmpty() || main.cache.getPocStav().isEmpty()) {
            return false;
        } else {
            main.program.setZacStav(main.cache.getPocStav().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(main.cache.getKonStav().toString().trim(), ","));
            //if (main.cache.getErrLine().contentEquals("")) {
            if (true) {
                main = main.subor.kontrolaProgramu(main);
                start = main.kontrola;
                if (start) {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * simulacia konecneho automatu
     */
    private void simSerKon() {
        main.vysledok = -1;
        spravne = 0;
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        for (int a = 0; a < main.program.getPocetTestov(); a++) {
            main.rotacie = 0;
            main.cache.setPaska(main.cache.getZazServ().get(a).getPaska());
            main.cache.setPocStav(main.cache.getZazServ().get(a).getStartQ());
            main.cache.setKonStav(main.cache.getZazServ().get(a).getKonQ());
            if (konSerKon()) {
                if (mode == 1)
                {
                    main.vysledok = 100;
                    return;
                }
                main = sim.simulaciaKonInit(main);
                while (sim.mozny) {
                    main = sim.simulaciaKonZhod(main);
                    int zhoda = main.program.getVyberI();
                    if (zhoda != -1) {
                        if (!main.program.getProgram().get(zhoda).getDupli().isEmpty()) {
                            main = sim.vyber(main, zhoda);
                            main.program.setVyberI(random());
                            zhoda = main.program.getVyberI();
                        }
                        main = sim.simulaciaKonSprac(main);
                    }
                    if (!sim.mozny) {
                        main = sim.simulaciaKonVyhod(main);
                        if (main.program.getSimOk() == main.cache.getZazServ().get(a).getSimOk()) {
                            spravne++;
                            System.out.println("  FSM simulation:: test " + a + " PASSED");                       //by SKor
                        }
                        break;
                    }

                    if (main.cache.getZazServ().get(a).getPocRot() < main.rotacie) {
                        break;
                    }
                    main.rotacie++;
                }
            }
        }
        main.vysledok = ((spravne * 100) / main.program.getPocetTestov());
    }

    /**
     * kontrola programu pre turingov stroj
     *
     * @return true pri spravnom programe
     */
    private Boolean konSerTur() {
        main.cache.setErrLine(null);
        main.cache.setPozPas(""); //by SKor: doplnene, aby tato hodnota nebola null
        main.paska.getPaska().clear();
        main.program.getProgram().clear();
        main.program.setPasInt(0);

        main.program.setPrerus(false);
        main.program.setVyberbool(false);
        main.paska.getPozPasky().clear();

        if (main.cache.getProgram().isEmpty()) {
            return false;
        } else if (main.cache.getPaska().isEmpty()) {
            return false;
        } else if (main.cache.getPocStav().isEmpty() || main.cache.getPocStav().isEmpty()) {
            return false;
        } else {
            main.program.setZacStav(main.cache.getPocStav().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(main.cache.getKonStav().toString().trim(), ","));
            if (true) {
                main = main.subor.kontrolaProgramu(main);
                if (main.kontrola) {
                    return true;
                }
            }
        }
        System.out.println("Program zly: " + main.cache.getErrLine());//by SKor
        return false;
    }

    /**
     * simulacia turingovho stroja
     */
    private void simSerTur() {
        main.vysledok = -1;
        spravne = 0;
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        for (int a = 0; a < main.program.getPocetTestov(); a++) {
            main.rotacie = 0;
            main.cache.setPaska(main.cache.getZazServ().get(a).getPaska());
            main.cache.setPocStav(main.cache.getZazServ().get(a).getStartQ());
            main.cache.setKonStav(main.cache.getZazServ().get(a).getKonQ());
            System.out.println("  Turing simulation:: test " + a + " spec: " + main.cache.getPaska() + " " + main.cache.getPocStav() + " " + main.cache.getKonStav());                       //by SKor
            if (konSerTur()) {
                if (mode == 1)
                {
                    main.vysledok = 100;
                    return;
                }
                main = sim.simulaciaTurInit(main);
                while (sim.mozny) {
                    main = sim.simulaciaTurZhod(main);
                    int zhoda = main.program.getVyberI();
                    if (zhoda != -1) {
                        if (!main.program.getProgram().get(zhoda).getDupli().isEmpty()) {
                            main = sim.vyber(main, zhoda);
                            main.program.setVyberI(random());
                            zhoda = main.program.getVyberI();
                        }
                        main = sim.simulaciaTurSprac(main);
                    }
                    if (!sim.mozny) {
                        main = sim.simulaciaTurVyhod(main);
                        if (main.program.getSimOk() == main.cache.getZazServ().get(a).getSimOk()) {
                            System.out.println("  Turing simulation:: test " + a + " PASSED");                       //by SKor
                            spravne++;
                        }
                        break;
                    }

                    if (main.cache.getZazServ().get(a).getPocRot() < main.rotacie) {
                        break;
                    }
                    main.rotacie++;
                }
            }
        }
        main.vysledok = ((spravne * 100) / main.program.getPocetTestov());
    }

    /**
     * automaticky vyber instrukcie pri viacerych moznostiach
     *
     * @return cislo vybranej instrukcie
     */
    private int random() {
        String[] vyber = main.program.getVyberstr().split("\n");
        int r = random.nextInt(vyber.length);
        String[] split = vyber[r].split(",");
        int i = Integer.parseInt(split[0]);
        return i;
    }

    /**
     * nacitanie xml z premennej
     *
     * @return xml dokument
     */
    private Document loadXMLFromString(String xml) throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        InputSource is = new InputSource(new StringReader(xml));
        return builder.parse(is);
    }

    /**
     * ziskanie stroja
     *
     * @return hodnota
     */
    private int getMachine(String machineName) {
        if (machineName.equals("turing")) {
            return 1;
        } else if (machineName.equals("stackm")) {
            return 2;
        } else {
            return 3;
        }
    }

    /**
     * ziskanie typu
     *
     * @return hodnota
     */
    private int getMachineType(int machine, String type) {
        // onetape|multitape|accFin|accEmpty|accFinEmpty
        if (machine == 1) {
            if (type.equals("onetape")) {
                return 0;
            } else {
                return 1;
            }
        } else {
            if (type.equals("accFin")) {
                return 1;
            } else if (type.equals("accEmpty")) {
                return 2;
            } else {
                return 3;
            }
        }
    }
    /**
     * Zahasovanie retazca funkciou MD5
     *
     * @return zahasovany retazec
     */
    private static String MD5(String md5) {
        try {
            java.security.MessageDigest md = java.security.MessageDigest.getInstance("MD5");
            byte[] array = md.digest(md5.getBytes());
            StringBuffer sb = new StringBuffer();
            for (int i = 0; i < array.length; ++i) {
                sb.append(Integer.toHexString((array[i] & 0xFF) | 0x100).substring(1, 3));
            }
            return sb.toString();
        } catch (java.security.NoSuchAlgorithmException e) {
        }
        return null;
    }

}
