/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.abstraktne;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

/**
 * trieda zabezpecujuca spacovanie nadialku cez service
 * @author Stano
 */
@WebService()
public class Service {

    /** instancia aplikacie */
    private static sk.tuke.fei.KpiEas.abstraktne.Premenne main;
    /** pocet spravne vyhodnotenych testov */
    private int spravne = 0;
    /** premenna nahodnych prememnych */
    private Random random = new Random();

    /**
     * komunikacia zo servrom
     */
    @WebMethod()
    public String serviceStart(@WebParam(name = "instrukcieStudenta") String instrukcieStudenta, @WebParam(name = "nazovSuboru") String nazovSuboru) {
        main = new Premenne();
        //webova sluzba ma dva parametre string instrukcii ktore zadal student
        //a druhy parameter je nazov suboru
        main.program.setService(true);
        //precita sa program z tvojho pc podla coho sa vykona kontrola
        main.cache.setProgram(instrukcieStudenta);
        try{
            main = readProgram(main, nazovSuboru);
        } catch (Exception e){
            System.out.println(e);
            return "zly vstupny subor";
        }
        serviceSim();
        //tu by sa mal odovzdat string s insktruciami od studenta akontrolovat
        //nech vrati tato metoda premennu vysledok s float cislom
        return Integer.toString(main.vysledok);

    }

    /**
     * spustenie samotnej simulacie s vyhodnotenim
     */
    private void serviceSim() {
        if (main.program.getTyp() == 1) {
            simSerTur();
        }
        if (main.program.getTyp() == 2) {
            simSerZas();
        }
        if (main.program.getTyp() == 3) {
            simSerKon();
        }
    }

    /**
     * nacitanie udajov zo suboru
     */
    private Premenne readProgram(Premenne get, String subor) {
        Premenne set = get;
        set.cache.getZazServ().clear();
        sk.tuke.fei.KpiEas.model.ZaznamService zaznam = null;
        File file = new File(System.getProperty("user.dir") + "\\" + subor);
        try {
            FileInputStream fstream = new FileInputStream(file);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));

            List<String> list = new ArrayList<String>();
            String line = "";
            int a = 0;
            while ((line = br.readLine()) != null) {
                if (a == 0) {
                    list = set.cache.delZnaky(line, ";");
                    set.program.setTyp(Integer.parseInt(list.get(0)));
                    set.program.setPocetTestov(Integer.parseInt(list.get(1)));
                    if (set.program.getTyp() == 2) {
                        set.program.setMode(Integer.parseInt(list.get(2)));
                    } else if (set.program.getTyp() == 1) {
                        if (Integer.parseInt(list.get(2)) == 0) {
                            set.program.setViacPas(false);
                        } else {
                            set.program.setViacPas(true);
                        }
                    }
                    a = 1;
                } else
                if (a == 1) {
                    zaznam = new sk.tuke.fei.KpiEas.model.ZaznamService();
                    list = set.cache.delZnaky(line, ";");
                    zaznam.setPocRot(Integer.parseInt(list.get(0)));
                    if (Integer.parseInt(list.get(1)) == 0) {
                        zaznam.setSimOk(false);
                    }
                    zaznam.setStartQ(list.get(2));
                    zaznam.setKonQ(list.get(3));
                    a = 2;
                } else
                if (a == 2) {
                    zaznam.setPaska(line);
                    if (set.program.getTyp() == 2) {
                        a = 3;
                    } else {
                        a = 1;
                    }
                } else
                if (a == 3) {
                    zaznam.setZasob(line);
                    a = 1;
                }
                if (zaznam != null) set.cache.pridajZaznam(zaznam);
            }
            in.close();
        } catch (Exception e) {
            System.out.println(e);
        }
        return set;
    }

    /**
     * kontrola programu pre zasobnikovy automat
     * @return true pri spravnom programe
     */
    private Boolean konSerZas() {
        main.cache.setErrLine(null);
        main.program.getProgram().clear();
        main.paska.getPaska().clear();

        main.program.setPrerus(false);
        main.program.setVyberbool(false);

        List poz = new ArrayList();
        poz.add(0);
        poz.add(0);
        main.paska.setPozPasky(poz);

        Boolean start = false;
        if (main.cache.getProgram().isEmpty()) {
            return false;
        } else if (main.cache.getPaska().isEmpty()) {
            return false;
        } else if (main.cache.getPocStav().isEmpty() || main.cache.getPocStav().isEmpty()) {
            return false;
        } else {
            main.program.setZacStav(main.cache.getPocStav().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(main.cache.getKonStav().toString().trim(), ","));
            main = main.subor.kontrolaProgramu(main);
            start = main.kontrola;
            if (start) {
                return true;
            }
        }
        return false;
    }

    /**
     * simulacia zasobnokoveho automatu
     */
    private void simSerZas() {
        main.vysledok = -1;
        spravne = 0;
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();        
        for (int a = 0; a < main.program.getPocetTestov(); a++) {
            main.rotacie = 0;
            main.cache.setPaska(main.cache.getZazServ().get(a).getPaska());
            main.cache.setZasobnik(main.cache.getZazServ().get(a).getZasob());
            main.cache.setPocStav(main.cache.getZazServ().get(a).getStartQ());
            main.cache.setKonStav(main.cache.getZazServ().get(a).getKonQ());
            if (konSerZas()) {
                main = sim.simulaciaZasInit(main);
                while (sim.mozny) {
                    main = sim.simulaciaZasZhod(main);
                    int zhoda = main.program.getVyberI();
                    if (zhoda != -1) {
                        if (!main.program.getProgram().get(zhoda).getDupli().isEmpty()) {
                            main = sim.vyber(main, zhoda);
                            main.program.setVyberI(random());
                            zhoda = main.program.getVyberI();
                        }
                        main = sim.simulaciaZasSprac(main);
                    }
                    if (!sim.mozny) {
                        main = sim.simulaciaZasVyhod(main);
                        if (main.program.getSimOk() == main.cache.getZazServ().get(a).getSimOk()) {
                            spravne++;
                        }
                        break;
                    }

                    if (main.cache.getZazServ().get(a).getPocRot() < main.rotacie) {
                        break;
                    }
                    main.rotacie++;
                }
            }
        }
        main.vysledok = ((spravne * 100) / main.program.getPocetTestov());
    }

    /**
     * kontrola programu pre konecny automat
     * @return true pri spravnom programe
     */
    private Boolean konSerKon() {
        main.cache.setErrLine(null);
        main.program.getProgram().clear();
        main.paska.getPaska().clear();

        main.program.setPrerus(false);
        main.program.setVyberbool(false);
        main.paska.getPozPasky().add(0);

        Boolean start = false;
        if (main.cache.getProgram().isEmpty()) {
            return false;
        } else if (main.cache.getPaska().isEmpty()) {
            return false;
        } else if (main.cache.getPocStav().isEmpty() || main.cache.getPocStav().isEmpty()) {
            return false;
        } else {
            main.program.setZacStav(main.cache.getPocStav().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(main.cache.getKonStav().toString().trim(), ","));
            if (main.cache.getErrLine().contentEquals("")) {
                main = main.subor.kontrolaProgramu(main);
                start = main.kontrola;
                if (start) {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * simulacia konecneho automatu
     */
    private void simSerKon() {
        main.vysledok = -1;
        spravne = 0;
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        for (int a = 0; a < main.program.getPocetTestov(); a++) {
            main.rotacie = 0;
            main.cache.setPaska(main.cache.getZazServ().get(a).getPaska());
            main.cache.setPocStav(main.cache.getZazServ().get(a).getStartQ());
            main.cache.setKonStav(main.cache.getZazServ().get(a).getKonQ());
            if (konSerKon()) {
                main = sim.simulaciaKonInit(main);
                while (sim.mozny) {
                    main = sim.simulaciaKonZhod(main);
                    int zhoda = main.program.getVyberI();
                    if (zhoda != -1) {
                        if (!main.program.getProgram().get(zhoda).getDupli().isEmpty()) {
                            main = sim.vyber(main, zhoda);
                            main.program.setVyberI(random());
                            zhoda = main.program.getVyberI();
                        }
                        main = sim.simulaciaKonSprac(main);
                    }
                    if (!sim.mozny) {
                        main = sim.simulaciaKonVyhod(main);
                        if (main.program.getSimOk() == main.cache.getZazServ().get(a).getSimOk()) {
                            spravne++;
                        }
                        break;
                    }

                    if (main.cache.getZazServ().get(a).getPocRot() < main.rotacie) {
                        break;
                    }
                    main.rotacie++;
                }
            }
        }
        main.vysledok = ((spravne * 100) / main.program.getPocetTestov());
    }

    /**
     * kontrola programu pre turingov stroj
     * @return true pri spravnom programe
     */
    private Boolean konSerTur() {
        main.cache.setErrLine(null);
        main.paska.getPaska().clear();
        main.program.getProgram().clear();
        main.program.setPasInt(0);

        main.program.setPrerus(false);
        main.program.setVyberbool(false);
        main.paska.getPozPasky().clear();

        Boolean start = false;
        if (main.cache.getProgram().isEmpty()) {
            return false;
        } else if (main.cache.getPaska().isEmpty()) {
            return false;
        } else if (main.cache.getPocStav().isEmpty() || main.cache.getPocStav().isEmpty()) {
            return false;
        } else {
            main.program.setZacStav(main.cache.getPocStav().toString().trim());
            main.program.setKonStav(main.cache.delZnaky(main.cache.getKonStav().toString().trim(), ","));
            if (main.cache.getErrLine().contentEquals("")) {
                main = main.subor.kontrolaProgramu(main);
                start = main.kontrola;
                if (start) {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * simulacia turingovho stroja
     */
    private void simSerTur() {
        main.vysledok = -1;
        spravne = 0;
        sk.tuke.fei.KpiEas.abstraktne.Simulacia sim = new sk.tuke.fei.KpiEas.abstraktne.Simulacia();
        for (int a = 0; a < main.program.getPocetTestov(); a++) {
            main.rotacie = 0;
            main.cache.setPaska(main.cache.getZazServ().get(a).getPaska());
            main.cache.setPocStav(main.cache.getZazServ().get(a).getStartQ());
            main.cache.setKonStav(main.cache.getZazServ().get(a).getKonQ());
            if (konSerTur()) {
                main = sim.simulaciaTurInit(main);
                while (sim.mozny) {
                    main = sim.simulaciaTurZhod(main);
                    int zhoda = main.program.getVyberI();
                    if (zhoda != -1) {
                        if (!main.program.getProgram().get(zhoda).getDupli().isEmpty()) {
                            main = sim.vyber(main, zhoda);
                            main.program.setVyberI(random());
                            zhoda = main.program.getVyberI();
                        }
                        main = sim.simulaciaTurSprac(main);
                    }
                    if (!sim.mozny) {
                        main = sim.simulaciaTurVyhod(main);
                        if (main.program.getSimOk() == main.cache.getZazServ().get(a).getSimOk()) {
                            spravne++;
                        }
                        break;
                    }

                    if (main.cache.getZazServ().get(a).getPocRot() < main.rotacie) {
                        break;
                    }
                    main.rotacie++;
                }
            }
        }
        main.vysledok = ((spravne * 100) / main.program.getPocetTestov());
    }

    /**
     * automaticky vyber instrukcie pri viacerych moznostiach
     * @return cislo vybranej instrukcie
     */
    private int random() {
        String[] vyber = main.program.getVyberstr().split("\n");
        int r = random.nextInt(vyber.length);
        String[] split = vyber[r].split(",");
        int i = Integer.parseInt(split[0]);
        return i;
    }
}
