/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.abstraktne;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JFileChooser;
import sk.tuke.fei.KpiEas.model.Instrukcia;

/**
 * trieda sluziaca na pracu zo suborom, citanie, kontrola spravnosti a formatovanie
 * pasok, zasobnika a programu automatov
 * @author Stano
 */

public class Subor {

    /**
     * konstruktor triedy subor
     */
    public Subor() {
    }
    /** instancia aplikacie */
    private static Premenne main;
    /** pomocna premenna typu instrukci */
    private Instrukcia zaznam;
    /** pomocna premenna typu instrukci */
    private Instrukcia kontrola;
    /** pomocna premenna typu instrukci */
    private Instrukcia kont;

    /**
     * metoda na kontrolu zadaneho programu pre
     * jednotlive automaty
     * @return true pri uspesnej kontrole bez chyb
     */
    public Premenne kontrolaProgramu(Premenne get) {
        main = get;
        main.cache.setErrLine("");
        if (main.program.getTyp() == 1) {
            main.kontrola = kontrolaProgramuTur();
        }
        if (main.program.getTyp() == 2) {
            main.kontrola = kontrolaProgramuZas();
        }
        if (main.program.getTyp() == 3) {
            main.kontrola = kontrolaProgramuKon();
        }
        return main;
    }

    /**
     * metoda pre inicializaciu pasok automatov
     */
    public Premenne nacitajPaska(Premenne get) {
        main = get;
        if (main.program.getTyp() == 1) {
            nacitajPaskuTur();
        }
        if (main.program.getTyp() == 2) {
            nacitajPaskuZas();
        }
        if (main.program.getTyp() == 3) {
            nacitajPaskuKon();
        }
        return main;
    }

    /**
     * nacitanie programu automatov zo suboru
     */
    public Premenne readProgram(Premenne get) {
        main = get;
        String wd = System.getProperty("user.dir");
        JFileChooser fc = new JFileChooser(wd);
        int rc = fc.showDialog(null, getLang(37));
        if (rc == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            String filename = file.getAbsolutePath();

            String prog = "";
            try {
                FileInputStream fstream = new FileInputStream(filename);
                DataInputStream in = new DataInputStream(fstream);
                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String line = "";
                int a = 0;
                while ((line = br.readLine()) != null) {
                    if (a == 0) {
                        main.cache.setPocStav(line);
                    } else if (a == 1) {
                        main.cache.setKonStav(line);
                    } else if (prog.isEmpty()) {
                        prog = line;
                    } else {
                        prog = prog + "\n" + line;
                    }
                    a++;
                }
                main.cache.setProgram(prog);
                in.close();
            } catch (Exception e) {
                setBar(getLang(6));
            }

        } else {
            setBar(getLang(3));
        }
        return main;
    }

    /**
     * ulozenie programov automatov do suboru
     */
    public Premenne saveProgram(Premenne get) {
        main = get;
        String wd = System.getProperty("user.dir");
        JFileChooser fc = new JFileChooser(wd);
        int rc = fc.showDialog(null, getLang(18));
        if (rc == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            String filename = file.getAbsolutePath();

            String vystup = "";
            vystup = main.cache.getProgram();
            String[] split = vystup.split("\n");
            int i = 0;
            try {
                PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(filename)), false);
                out.write(main.cache.getPocStav());
                out.println();
                out.write(main.cache.getKonStav());
                out.println();
                while (i < split.length) {
                    out.write(split[i].toString());
                    out.println();
                    i++;
                }
                out.close();
            } catch (Exception ex) {
                setBar(getLang(23));
            }

        } else {
            setBar(getLang(3));
        }
        return main;
    }

    /**
     * kontrola programu zasobnikoveho automatu
     * @return true pri uspesnej kontrole
     */
    private Boolean kontrolaProgramuZas() {
        main.cache.setErrLine("");
        Boolean usp = false;
        main.program.getProgram().clear();
        int i = 0;
        Boolean start = false;
        String text, split[];
        text = main.cache.getProgram();
        split = text.split("\n");
        for (i = 0; i < split.length; i++) {
            if (split[i].toString().trim().length() != 0) {
                kontrola = kontrolaInstrukcieZas(split[i].toString().trim());
                if (main.cache.getErrLine().isEmpty()) {
                    kont = kontrolaDuplicityZas(kontrola);
                    kontrola = kont;
                    if (main.cache.getErrLine().isEmpty()) {
                        main.program.getProgram().add(kontrola);
                    } else {
                        break;
                    }
                } else {
                    break;
                }
                if (i == (split.length - 1)) {
                    usp = true;
                }
            }
        }
        nacitajPaskuZas();
        nacitajZasobnik();

        if ((usp) & (main.cache.getErrLine().isEmpty())) {
            start = true;
        }
        return start;
    }

    /**
     * kontrola instrukcie zasobnikoveho automatu
     * @param line string zapis kontrolovaneho riadku
     * @return zaznam instrukdie vo formate instrukcie
     */
    private Instrukcia kontrolaInstrukcieZas(String line) {
        List<String> progstr = main.cache.delZnaky(line, ",");
        zaznam = new Instrukcia();
        zaznam.setLine(line);
        if (progstr.size() > 5) {
            setBar(getLang(7) + line);
        } else if (progstr.size() < 5) {
            setBar(getLang(8) + line);
        } else {
            for (int i = 0; i < progstr.size(); i++) {
                if (i == 0) {
                    if (progstr.get(0).length() != 0) {
                        zaznam.setStav1(progstr.get(0));
                    } else {
                        setBar(getLang(9) + line);
                    }
                }
                if (i == 1) {
                    if (progstr.get(1).length() != 0) {
                        zaznam.addZnak1(progstr.get(1));
                    } else {
                        zaznam.addZnak1("&");
                    }
                }
                if (i == 2) {
                    if (progstr.get(2).length() != 0) {
                        zaznam.addZnak2(progstr.get(2));
                    } else {
                        setBar(getLang(10) + line);
                    }
                }
                if (i == 3) {
                    if (progstr.get(3).length() != 0) {
                        zaznam.setStav2(progstr.get(3));
                    } else {
                        setBar(getLang(11) + line);
                    }
                }
                if (i == 4) {
                    zaznam.setTop(progstr.get(4));
                    List<String> spl = new ArrayList<String>();
                    spl = main.cache.delZnaky(progstr.get(4), ".");
                    zaznam.setSmer(spl);
                }
                if (!(main.cache.getErrLine().isEmpty())) {
                    break;
                }
            }
        }
        return zaznam;
    }

    /**
     * kontrola duplicity zaznamov instrukcie zasobnikoveho automatu
     * @param zaznam kontrolovana instrukcia
     * @return upravena instrukcia so zaznamom o duplicite
     */
    private Instrukcia kontrolaDuplicityZas(Instrukcia zaznam) {
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                    & (main.program.getProgram().get(i).getStav2().contentEquals(zaznam.getStav2()))
                    & (main.program.getProgram().get(i).getZnak1().get(0).contentEquals(zaznam.getZnak1().get(0)))
                    & (isSame(main.program.getProgram().get(i).getSmer(), zaznam.getSmer()))
                    & (main.program.getProgram().get(i).getZnak2().get(0).contentEquals(zaznam.getZnak2().get(0)))) {
                setBar(getLang(19) + zaznam.getLine() + getLang(20));
            } else {
                if (zaznam.getZnak1().get(0).contains("&")) {
                    if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                            & (main.program.getProgram().get(i).getZnak2().get(0).contentEquals(zaznam.getZnak2().get(0)))) {
                        main.program.getProgram().get(i).getDupli().add(main.program.getProgram().size());
                        if (main.program.getProgram().get(i).getZnak1().get(0).contains("&")) {
                            zaznam.getDupli().add(i);
                        }
                    }
                } else {
                    if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                            & (main.program.getProgram().get(i).getZnak2().get(0).contentEquals(zaznam.getZnak2().get(0)))
                            & (main.program.getProgram().get(i).getZnak1().get(0).contains("&"))) {
                        zaznam.getDupli().add(i);
                    }
                    if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                            & (main.program.getProgram().get(i).getZnak2().get(0).contentEquals(zaznam.getZnak2().get(0)))
                            & (main.program.getProgram().get(i).getZnak1().get(0).contentEquals(zaznam.getZnak1().get(0)))) {
                        main.program.getProgram().get(i).getDupli().add(main.program.getProgram().size());
                        zaznam.getDupli().add(i);
                    }
                }
            }
        }
        return zaznam;
    }

    /**
     * porivnanie dvoch poli znakov
     * @param one prve porovnavane pole
     * @param two druhe porovnavane pole
     * @return true ak sa polia zhoduju
     */
    private Boolean isSame(List one, List two) {
        Boolean is = true;
        if (one.size() != two.size()) {
            return false;
        }
        for (int i = 0; i < one.size(); i++) {
            if (!(one.get(i).toString().contains(two.get(i).toString()))) {
                is = false;
                break;
            }
        }
        return is;
    }

    /**
     * metoda na kontrolu duplicity pasok
     * @param jedna prva paska kontroly
     * @param dva druha paska kontroly
     * @return true pri zhode pasok
     */
    private Boolean duplicitaPaska(List<String> jedna, List<String> dva) {
        if (jedna.size() != dva.size()) {
            return false;
        }
        for (int i = 0; i < jedna.size(); i++) {
            if (!jedna.get(i).contentEquals(dva.get(i))) {
                return false;
            }
        }
        return true;
    }

    /**
     * nastavanie cybovych hlaseni
     * @param line nastavovane hlasenie
     */
    private void setBar(String line) {
        main.cache.setErrLine(line);
    }

    /**
     * metoda na ziskanie jazykovych mutacii hlaseni
     * @param i poradove cislo hlasenia
     * @return chybove hlasenie
     */
    private String getLang(int i) {
        String line = main.lang.getText(i).toString();
        return line;
    }

    /**
     * kontrola programu konecneho automatu
     * @return true pri uspesnej kontrole
     */
    private Boolean kontrolaProgramuKon() {
        Boolean usp = false;
        main.program.getProgram().clear();
        int i = 0;
        Boolean start = false;
        String text, split[];
        text = main.cache.getProgram();
        split = text.split("\n");
        for (i = 0; i < split.length; i++) {
            if (split[i].toString().trim().length() != 0) {
                kontrola = kontrolaInstrukcieKon(split[i].toString().trim());
                if (main.cache.getErrLine().isEmpty()) {
                    kont = kontrolaDuplicityKon(kontrola);
                    kontrola = kont;
                    if (main.cache.getErrLine().isEmpty()) {
                        main.program.getProgram().add(kontrola);
                    } else {
                        break;
                    }
                } else {
                    break;
                }
                if (i == (split.length - 1)) {
                    usp = true;
                }
            }
        }
        nacitajPaskuKon();
        if ((usp) & (main.cache.getErrLine().isEmpty())) {
            start = true;
        }
        return start;
    }

    /**
     * kontrola instrukcie konecneho automatu
     * @param line string kontrolovaneho riadku
     * @return zaznam vo formate instrukcie
     */
    private Instrukcia kontrolaInstrukcieKon(String line) {
        List<String> progstr = main.cache.delZnaky(line, ",");
        zaznam = new Instrukcia();
        zaznam.setLine(line);
        if (progstr.size() > 4) {
            setBar(getLang(7) + line);
        } else if (progstr.size() < 3) {
            setBar(getLang(8) + line);
        } else {
            for (int i = 0; i < progstr.size(); i++) {
                if (i == 0) {
                    if (progstr.get(0).length() != 0) {
                        zaznam.setStav1(progstr.get(0));
                    } else {
                        setBar(getLang(9) + line);
                    }
                }
                if (i == 1) {
                    if (progstr.get(1).length() != 0) {
                        zaznam.addZnak1(progstr.get(1));
                    } else {
                        setBar(getLang(12) + line);
                    }
                }
                if (i == 2) {
                    if (progstr.get(2).length() != 0) {
                        zaznam.setStav2(progstr.get(2));
                    } else {
                        setBar(getLang(11) + line);
                    }
                }
                if (i == 3) {
                    String s = progstr.get(3).toLowerCase().trim();
                    if ((s.contains("l")) || (s.contains("r")) || (s.contains("-"))) {
                        zaznam.getSmer().add(s);
                    } else {
                        setBar(getLang(13) + line);
                    }
                }
                if (!(main.cache.getErrLine().isEmpty())) {
                    break;
                }
            }
            if (zaznam.getSmer().isEmpty()) {
                zaznam.getSmer().add("r");
            }
        }
        return zaznam;
    }

    /**
     * kontrola duplicity instrukcie konecneho automatu
     * @param zaznam kontrolovana instrukcia
     * @return upravena instrukcia o duplicitu
     */
    private Instrukcia kontrolaDuplicityKon(Instrukcia zaznam) {
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                    & (main.program.getProgram().get(i).getStav2().contentEquals(zaznam.getStav2()))
                    & (main.program.getProgram().get(i).getZnak1().get(0).contentEquals(zaznam.getZnak1().get(0)))
                    & (duplicitaPaska(main.program.getProgram().get(i).getSmer(), zaznam.getSmer()))) {
                setBar(getLang(19) + zaznam.getLine() + getLang(20));
            } else {
                if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                        & (main.program.getProgram().get(i).getZnak1().get(0).contentEquals(zaznam.getZnak1().get(0)))) {
                    zaznam.getDupli().add(i);
                    main.program.getProgram().get(i).getDupli().add(main.program.getProgram().size());
                }
            }
        }
        return zaznam;
    }

    /**
     * kontrola programu turingovho stroja
     * @return true pri spravnosti zadaneho stroja
     */
    private Boolean kontrolaProgramuTur() {
        Boolean usp = false;
        main.program.getProgram().clear();
        main.program.setPasInt(0);
        Boolean start = false;
        String text, split[];
        text = main.cache.getProgram();
        split = text.split("\n");
        for (int i = 0; i < split.length; i++) {
            if (split[i].toString().trim().length() != 0) {
                kontrola = kontrolaInstrukcieTur(split[i].toString().trim());
                if (main.cache.getErrLine().isEmpty()) {
                    kont = kontrolaDuplicityTur(kontrola);
                    kontrola = kont;
                    if (main.cache.getErrLine().isEmpty()) {
                        main.program.getProgram().add(kontrola);
                    } else {
                        break;
                    }
                } else {
                    break;
                }
                if (i == (split.length - 1)) {
                    usp = true;
                }
            }
        }
        nacitajPaskuTur();
        if (main.cache.getErrLine().contentEquals("")) {
            setPozicieTur();
        }
        if ((usp) & (main.cache.getErrLine().isEmpty())) {
            start = true;
        }
        return start;
    }

    /**
     * kontrola instrukcie turingovho stroja
     * @param line string konrolovaneho riadku programu
     * @return zaznam vo formate instrukcie
     */
    private Instrukcia kontrolaInstrukcieTur(String line) {
        List<String> progstr = main.cache.delZnaky(line, ",");
        zaznam = new Instrukcia();
        zaznam.setLine(line);
        zaznam.getDupli().clear();
        if (progstr.size() > 5) {
            setBar(getLang(7) + line);
        } else if (progstr.size() < 5) {
            setBar(getLang(8) + line);
        } else {
            for (int i = 0; i < progstr.size(); i++) {
                if (i == 0) {
                    if (progstr.get(0).length() != 0) {
                        zaznam.setStav1(progstr.get(0).toString().trim());
                    } else {
                        setBar(getLang(9) + line);
                    }
                }
                if (i == 1) {
                    zaznam = kontrolaModeTur(zaznam, progstr.get(1).toString().trim(), 1);
                }
                if (i == 2) {
                    zaznam = kontrolaModeTur(zaznam, progstr.get(2).toString().trim(), 2);
                }
                if (i == 3) {
                    if (progstr.get(3).length() != 0) {
                        zaznam.setStav2(progstr.get(3).toString().trim());
                    } else {
                        setBar(getLang(11) + line);
                    }
                }
                if (i == 4) {
                    zaznam = kontrolaModeTur(zaznam, progstr.get(4).toString().trim(), 4);
                }
                if (!(main.cache.getErrLine().isEmpty())) {
                    break;
                }
            }
        }
        return zaznam;
    }

    /**
     * kontrola instrukcie pri volabe viacerych pasok
     * @param mode upravovana instrukcia turingovho stroja
     * @param split testovany string
     * @param k pozicia testovaneho znaku
     * @return upravena instrukcia
     */
    private Instrukcia kontrolaModeTur(Instrukcia mode, String split, int k) {
        List<String> modeStr = new ArrayList();
        String[] spl = null;
        if (main.program.getViacPas()) {
            String splStr = "";
            spl = split.trim().split("");
            if (!(spl[1].contentEquals("[")) || !(spl[spl.length - 1].contentEquals("]"))) {
                setBar(getLang(13) + mode.getLine());
            } else {
                for (int j = 2; j < (spl.length - 1); j++) {
                    splStr = splStr + spl[j];
                }
                List<String> passtr = main.cache.delZnaky(splStr, ",");
                for (int m = 0; m < passtr.size(); m++) {
                    if (k != 4) {
                        if (passtr.get(m).length() == 1) {
                            modeStr.add(passtr.get(m));
                        } else if (passtr.get(m).length() == 0) {
                            setBar(getLang(14) + mode.getLine());
                        } else {
                            spl = passtr.get(m).trim().split("");
                            if (!(spl[1].contentEquals("[")) || !(spl[spl.length - 1].contentEquals("]"))) {
                                setBar(getLang(13) + mode.getLine());
                            } else {
                                modeStr.add(passtr.get(m));
                            }
                        }
                    } else {
                        if ((passtr.get(m).toLowerCase().contentEquals("l")) || (passtr.get(m).toLowerCase().contentEquals("r"))
                                || (passtr.get(m).toLowerCase().contentEquals("-"))) {
                            modeStr.add(passtr.get(m).toLowerCase());
                        } else {
                            setBar(getLang(12) + mode.getLine());
                        }
                    }
                }
                if (main.program.getPasInt() == 0) {
                    main.program.setPasInt(passtr.size());
                }
                if (main.program.getPasInt() != passtr.size()) {
                    setBar(getLang(17) + mode.getLine());
                }
            }
        } else {
            main.program.setPasInt(1);
            if (k == 4) {
                if ((split.toLowerCase().contentEquals("l")) || (split.toLowerCase().contentEquals("r"))
                        || (split.toLowerCase().contentEquals("-"))) {
                    modeStr.add(split.toLowerCase());
                } else {
                    setBar(getLang(12) + mode.getLine());
                }
            } else {
                if (!split.isEmpty()) {
                    modeStr.add(split);
                } else {
                    setBar(getLang(14) + mode.getLine());
                }
            }
        }
        if (k == 1) {
            mode.setZnak1(modeStr);
        }
        if (k == 2) {
            mode.setZnak2(modeStr);
        }
        if (k == 4) {
            mode.setSmer(modeStr);
        }
        return mode;
    }

    /**
     * kontrola duplicity instrukcie turingovho stroja
     * @param zaznam spracovavana instrukcia
     * @return poupravena instrukcia
     */
    private Instrukcia kontrolaDuplicityTur(Instrukcia zaznam) {
        for (int i = 0; i < main.program.getProgram().size(); i++) {
            if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                    & (duplicitaPaska(main.program.getProgram().get(i).getZnak1(), zaznam.getZnak1()))
                    & (duplicitaPaska(main.program.getProgram().get(i).getZnak2(), zaznam.getZnak2()))
                    & (main.program.getProgram().get(i).getStav2().contentEquals(zaznam.getStav2()))
                    & (duplicitaPaska(main.program.getProgram().get(i).getSmer(), zaznam.getSmer()))) {
                setBar(getLang(19) + zaznam.getLine() + getLang(20));
            } else {
                if ((main.program.getProgram().get(i).getStav1().contentEquals(zaznam.getStav1()))
                        & (duplicitaPaska(main.program.getProgram().get(i).getZnak1(), zaznam.getZnak1()))) {
                    if (main.program.getProgram().get(i).getDupli().isEmpty()) {
                        zaznam.getDupli().add(i);
                        main.program.getProgram().get(i).getDupli().add(main.program.getProgram().size());
                    } else {
                        zaznam.getDupli().addAll(main.program.getProgram().get(i).getDupli());
                        main.program.getProgram().get(i).getDupli().add(main.program.getProgram().size());
                        break;
                    }
                }
            }
        }
        return zaznam;
    }

    /**
     * nastavenie pozicie pasok pri zaciatku spracovania
     */
    private void setPozicieTur() {
        main.paska.getPozPasky().clear();
        String a = main.cache.getPozPas();
        int b = -1;
        if (main.program.getViacPas()) {
            if (!a.contains("")) {
                List<String> c = main.cache.delZnaky(a, ",");
                if (c.size() == main.program.getPasInt()) {
                    for (int i = 0; i < main.program.getPasInt(); i++) {
                        try {
                            b = Integer.parseInt(c.get(i));
                        } catch (Exception ex) {
                            setBar(getLang(4));
                        }
                        if ((b >= 0) & (b < main.paska.getPaska().get(i).size())) {
                            main.paska.getPozPasky().add(b);
                        } else {
                            setBar(getLang(5));
                        }
                    }
                } else {
                    setBar(getLang(10));
                }
            } else {
                for (int i = 0; i < main.program.getPasInt(); i++) {
                    main.paska.getPozPasky().add(0);
                }
            }
        } else {
            if (!a.contains("")) {
                try {
                    b = Integer.parseInt(a);
                } catch (Exception ex) {
                    setBar(getLang(4));
                }
                if ((b >= 0) & (b < main.paska.getPaska().get(0).size())) {
                    main.paska.getPozPasky().add(b);
                } else {
                    setBar(getLang(5));
                }
            } else {
                main.paska.getPozPasky().add(0);
            }
        }

    }

    /**
     * nacitanie a sformatovanie pasky zasobnikovho automatu
     */
    private void nacitajPaskuZas() {
        main.paska.getPaska().clear();
        main.paska.getPaska().add(new ArrayList<String>());
        List<String> paska = main.paska.getPaska().get(0);

        String record = main.cache.getPaska();
        List<String> strPaska = main.cache.delZnaky(record, ",");
        if (strPaska.isEmpty()) {
            setBar(getLang(16));
        } else {
            for (int i = 0; i < strPaska.size(); i++) {
                paska.add(strPaska.get(i));
                if (strPaska.get(i).contentEquals("")) {
                    setBar(getLang(25) + ",,");
                }
            }
            paska.add("&");
        }
    }

    /**
     * nacitanie a sformatovanie pasky konecneho automatu
     */
    private void nacitajPaskuKon() {
        main.paska.getPaska().clear();
        main.paska.getPaska().add(new ArrayList<String>());
        List<String> paska = main.paska.getPaska().get(0);

        String record = main.cache.getPaska();
        List<String> strPaska = main.cache.delZnaky(record, ",");
        if (strPaska.isEmpty()) {
            setBar(getLang(16));
        } else {
            for (int i = 0; i < strPaska.size(); i++) {
                paska.add(strPaska.get(i));
                if (strPaska.get(i).contentEquals("")) {
                    setBar(getLang(25) + ",,");
                }
            }
        }
    }

    /**
     * nacitanie pasky pre strje zo suboru
     * @param pas pri false ide o zasobnik kasobnikoveho automatu
     */
    public Premenne readPaska(Premenne get, Boolean pas) {
        main = get;
        String lang = "";
        if (pas) {
            lang = getLang(39);
        } else {
            lang = getLang(41);
        }
        String wd = System.getProperty("user.dir");
        JFileChooser fc = new JFileChooser(wd);
        int rc = fc.showDialog(null, lang);
        if (rc == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            String filename = file.getAbsolutePath();

            try {
                FileInputStream fstream = new FileInputStream(filename);
                DataInputStream in = new DataInputStream(fstream);
                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String line = "", put = "";
                while ((line = br.readLine()) != null) {
                    put = put + line;
                }
                if (pas) {
                    main.cache.setPaska(put);
                } else {
                    main.cache.setZasobnik(put);
                }
                in.close();
            } catch (Exception e) {
                if (pas) {
                    setBar(getLang(21));
                } else {
                    setBar(getLang(17));
                }
            }
        } else {
            setBar(getLang(3));
        }
        return main;
    }

    /**
     * ulozenie pasky automatov do suboru
     * @param pas pri false ide o zasobnik kasobnikoveho automatu
     */
    public Premenne savePaska(Premenne get, Boolean pas) {
        main = get;
        String lang = "";
        if (pas) {
            lang = getLang(38);
        } else {
            lang = getLang(40);
        }
        String wd = System.getProperty("user.dir");
        JFileChooser fc = new JFileChooser(wd);
        int rc = fc.showDialog(null, lang);
        if (rc == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            String filename = file.getAbsolutePath();

            String vystup = "";
            if (pas) {
                vystup = main.cache.getPaska();
            } else {
                vystup = main.cache.getZasobnik();
            }
            try {
                PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(filename)), false);
                out.write(vystup);
                out.close();
            } catch (Exception ex) {
                if (pas) {
                    setBar(getLang(22));
                } else {
                    setBar(getLang(24));
                }
            }

        } else {
            setBar(getLang(3));
        }
        return main;
    }

    /**
     * nacitanie a formatovanie sazobnika zasobnikoveho automatu
     */
    private void nacitajZasobnik() {
        main.paska.getPaska().add(new ArrayList<String>());
        List<String> zasobnik = main.paska.getPaska().get(1);
        String record = main.cache.getZasobnik();
        if (!record.contains("")) {
            List<String> strPaska = main.cache.delZnaky(record, ",");
            if (strPaska.isEmpty()) {
                setBar(getLang(13));
            } else {
                for (int i = 0; i < strPaska.size(); i++) {
                    zasobnik.add(strPaska.get(i));
                    if (strPaska.get(i).contentEquals("")) {
                        setBar(getLang(14) + ",,");
                    }
                }
            }
        } else {
            zasobnik.add("Z");
        }
    }

    /**
     * nacitanie a formatovanie pasky turingovho stroja
     */
    private void nacitajPaskuTur() {
        List tape;
        main.paska.getPaska().clear();
        if (main.program.getViacPas()) {
            for (int l = 0; l < main.program.getPasInt(); l++) {
                tape = new ArrayList();
                main.paska.getPaska().add(tape);
            }
        } else {
            tape = new ArrayList();
            main.paska.getPaska().add(tape);
        }
        for (int t = 0; t < main.paska.getPaska().size(); t++) {
            main.paska.getPaska().get(t).clear();
        }

        String record = main.cache.getPaska();
        List<String> strPaska = main.cache.delZnaky(record, ",");
        if (main.program.getViacPas()) {
            for (int i = 0; i < strPaska.size(); i++) {
                String[] spl = null;
                String splStr = "";
                spl = strPaska.get(i).toString().trim().split("");
                if (!(spl[1].contentEquals("[")) || !(spl[spl.length - 1].contentEquals("]"))) {
                    setBar(getLang(24) + strPaska.get(i).toString());
                } else {
                    for (int k = 2; k < (spl.length - 1); k++) {
                        splStr = splStr + spl[k];
                    }
                    List<String> strMode = main.cache.delZnaky(splStr, ",");
                    if (main.program.getPasInt() != strMode.size()) {
                        setBar(getLang(26) + strPaska.get(i).toString());
                    } else {
                        for (int m = 0; m < strMode.size(); m++) {
                            List<String> p = main.paska.getPaska().get(m);
                            p.add(strMode.get(m).toString());
                            if (strMode.get(m).contentEquals("")) {
                                setBar(getLang(25) + strPaska.get(i).toString());
                            }
                        }
                    }
                }
            }
        } else {
            if (strPaska.isEmpty()) {
                setBar(getLang(16));
            } else {
                for (int i = 0; i < strPaska.size(); i++) {
                    main.paska.getPaska().get(0).add(strPaska.get(i));
                    if (strPaska.get(i).contentEquals("")) {
                        setBar(getLang(25) + ",,");
                    }
                }
            }
        }
    }
}
