/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sk.tuke.fei.KpiEas.model;

import java.util.ArrayList;
import java.util.List;

/**
 * trieda pre uchovanie migrujucich informacii medzi
 * jednotlivymi castami aplikacie
 * @author Stano
 */
public class Cache {

    /** program automatov v neformatovanej podobe */
    private String program = null;
    /** paska automatov v neformatovanej podobe */
    private String paska = null;
    /** zasobnik zasobnikoveho automatu v neformatovanej podobe */
    private String zasobnik = null;
    /** pozicia pasok turingovho stoja v neformatovanej podobe */
    private String pozPas = null;
    /** status bar pre chybovehlasnia a zavercne hlasenia */
    private String errLine = null;
    /** text edukacnej zlozky */
    private String edukLine = null;
    /** pociatocny stav strojov */
    private String pocStav = null;
    /** konecne stavy strojov v neformatovanej podobe */
    private String konStav = null;
    /** vypis pasok pre graficke rozhranie */
    private List<String> vypPasky = null;
    private List<sk.tuke.fei.KpiEas.model.ZaznamService> ZazServ = new ArrayList<ZaznamService>();

    /**
     * konstruktor objektu Casche
     */
    public Cache() {
    }

    /**
     * delenie instrukcii navrhnute pre spracovanie automatov
     * @param line string sracovanych instrukcii
     * @param znak znak na rozdelenie casti instrukcie
     * @return rozdelena inatrukcia
     */
    public List<String> delZnaky(String line, String znak) {
        String[] split = line.split("");
        int zatint = 0;
        String str = "";
        List<String> progstr = new ArrayList<String>();
        for (int i = 0; i < split.length; i++) {
            if ((split[i].contentEquals(znak)) & (zatint == 0)) {
                progstr.add(str.trim());
                zatint = 0;
                str = "";
            } else if (split[i].contentEquals("[")) {
                str = str + split[i];
                zatint++;
            } else if (split[i].contentEquals("]")) {
                str = str + split[i];
                zatint--;
            } else {
                str = str + split[i];
            }
            if ((i == split.length - 1) & !(split[i].contentEquals(znak))) {
                zatint = 0;
                progstr.add(str.trim());
            }
        }
        return progstr;
    }

    /**
     * @return the program
     */
    public String getProgram() {
        return program;
    }

    /**
     * @param program the program to set
     */
    public void setProgram(String program) {
        this.program = program;
    }

    /**
     * @return the paska
     */
    public String getPaska() {
        return paska;
    }

    /**
     * @param paska the paska to set
     */
    public void setPaska(String paska) {
        this.paska = paska;
    }

    /**
     * @return the zasobnik
     */
    public String getZasobnik() {
        return zasobnik;
    }

    /**
     * @param zasobnik the zasobnik to set
     */
    public void setZasobnik(String zasobnik) {
        this.zasobnik = zasobnik;
    }

    /**
     * @return the pozPas
     */
       public String getPozPas() {
        return pozPas;
    }

    /**
     * @param pozPas the pozPas to set
     */
    public void setPozPas(String pozPas) {
        this.pozPas = pozPas;
    }

    /**
     * @return the errLine
     */
    public String getErrLine() {
        return errLine;
    }

    /**
     * @param errLine the errLine to set
     */
    public void setErrLine(String errLine) {
        this.errLine = errLine;
    }

    /**
     * cistenie errline
     */
    public void clrErrLine() {
        this.errLine = null;
    }

    /**
     * @return the pocStav
     */
    public String getPocStav() {
        return pocStav;
    }

    /**
     * @param pocStav the pocStav to set
     */
    public void setPocStav(String pocStav) {
        this.pocStav = pocStav;
    }

    /**
     * @return the konStav
     */
    public String getKonStav() {
        return konStav;
    }

    /**
     * @param konStav the konStav to set
     */
    public void setKonStav(String konStav) {
        this.konStav = konStav;
    }

    /**
     * @return the edukLine
     */
    public String getEdukLine() {
        return edukLine;
    }

    /**
     * @param edukLine the edukLine to set
     */
    public void setEdukLine(String edukLine) {
        this.edukLine = edukLine;
    }

    /**
     * @return the vypPasky
     */
    public List<String> getVypPasky() {
        return vypPasky;
    }

    /**
     * @param vypPasky the vypPasky to set
     */
    public void setVypPasky(List<String> vypPasky) {
        this.vypPasky = vypPasky;
    }

    /**
     * @return the ZazServ
     */
    public List<sk.tuke.fei.KpiEas.model.ZaznamService> getZazServ() {
        return ZazServ;
    }

    /**
     * @param ZazServ the ZazServ to set
     */
    public void setZazServ(List<sk.tuke.fei.KpiEas.model.ZaznamService> ZazServ) {
        this.ZazServ = ZazServ;
    }

    /**
     * @param Zaz pridany jeden zaznam
     */
    public void pridajZaznam(sk.tuke.fei.KpiEas.model.ZaznamService Zaz) {
        this.ZazServ.add(Zaz);
    }
}
