<?php


/**
 * Question type class for the abstraktne question type.
 *
 * @package    qtype
 * @subpackage abstraktne
 * @copyright  2013 Lukas Malik
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */


defined('MOODLE_INTERNAL') || die();

require_once($CFG->libdir . '/questionlib.php');
require_once($CFG->dirroot . '/question/engine/lib.php');
require_once($CFG->dirroot . '/question/type/abstraktne/question.php');


/**
 * Abstraktne question type.
 *
 * @copyright  2013 Lukas Malik
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
class qtype_abstraktne extends question_type {
    public function extra_question_fields() {
        return array('question_abstraktne','formatovana_odpoved','hod_data','typ_vyhodnocovania','mod_otazky');
    }

    public function questionid_column_name() {
        return 'question';
    }

    public function move_files($questionid, $oldcontextid, $newcontextid) {
        parent::move_files($questionid, $oldcontextid, $newcontextid);
        $this->move_files_in_answers($questionid, $oldcontextid, $newcontextid);
        $this->move_files_in_hints($questionid, $oldcontextid, $newcontextid);
    }

    protected function delete_files($questionid, $contextid) {
        parent::delete_files($questionid, $contextid);
        $this->delete_files_in_answers($questionid, $contextid);
        $this->delete_files_in_hints($questionid, $contextid);
    }

    public function save_question_options($question) {
        
		
        if($res=parent::save_question_options($question)) {
            return $res;
        } else {
            return true;
        }
        
    }

    protected function initialise_question_instance(question_definition $question, $questiondata) {
        parent::initialise_question_instance($question, $questiondata);
        $this->initialise_question_answers($question, $questiondata);
    }

    public function get_random_guess_score($questiondata) {
        foreach ($questiondata->options->answers as $aid => $answer) {
            if ('*' == trim($answer->answer)) {
                return $answer->fraction;
            }
        }
        return 0;
    }

    public function get_possible_responses($questiondata) {
        
        return array($questiondata->id => array("123"));
    }
}
