<?php


/**
 * abstraktne question renderer class.
 *
 * @package    qtype
 * @subpackage abstraktne
 * @copyright  2013 Lukas Malik
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */


defined('MOODLE_INTERNAL') || die();


/**
 * Generates the output for abstraktne questions.
 *
 * @copyright  2013 Lukas Malik
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
class qtype_abstraktne_renderer extends qtype_renderer {
    public function formulation_and_controls(question_attempt $qa,
            question_display_options $options) {
        global $PAGE;
        global $CFG;
        $PAGE->requires->js("/question/type/abstraktne/scripts/sourceCode.js");
        $question = $qa->get_question();
       // echo "<pre>";
       // print_r($qa);
      //  echo "</pre>";
        
        
        
        $questiontext = $question->format_questiontext($qa);
        $result = html_writer::tag('div', $questiontext, array('class' => 'qtext'));
        //$result .= "<textarea style=\"color:red; background-color: lightblue; border-style: solid\" cols=90 rows=10 readonly=\"readonly\" disabled=\"disabled\">".get_string('help', 'qtype_abstraktne')."</textarea>";
       
        ////////////////////
        $answertype = '';
        $for_odp = $question->formatovana_odpoved;
        $readonly = '';
        if ($options->readonly) {
            $readonly = 'readonly';
        }
        $class = '';
        $feedbackimg = '';
        if ($options->correctness) {
            $fraction = $qa->get_fraction();
            $class = $this->feedback_class($fraction);
            $feedbackimg = $this->feedback_image($fraction);
        }
        if ($question->mod_otazky == 1)
        { 
            if ($this->check_answer_format_count($for_odp))
            {
                
                preg_match_all("/<answer>(.*?)<\/answer>/is",$for_odp,$matches);
                $count = 0;
                foreach ($matches[1] as $match)
                {
                    $inputname = $qa->get_qt_field_name('answer_'.$count);
                    
                    $currentanswer = $qa->get_last_qt_var('answer_'.$count);
                    $isSetSize = false;
                    $match = trim($match);
                    $value = @$state->responses[$count];
                    if(strstr($match, PHP_EOL)) 
                    {   
                        $size = substr_count($match,PHP_EOL); 
                        $line = $this->get_textarea_tag(30, $size, $class, $inputname, $readonly, $currentanswer);
                    }
                    else
                    {
                        if ($isSetSize)
                        {
                            $myTagSize = strlen($match);
                        }
                        
                        else
                        {
                            $myTagSize = 40;
                        }
                        $line = $this->get_inputtext_tag($myTagSize, $class, $inputname, $readonly, $count, $currentanswer);
                    }
                    
                    $for_odp = preg_replace("/<answer>(.*?)<\/answer>/si", $line, $for_odp, 1);
                    $count++;
                }
                $answertype = "<pre>".$for_odp."</pre>";
                
            }
            
        }
        else
        
        {
            
            $count = 1;
            $value = "";
            if (isset($state->responses[0]))
            {
                $value = $state->responses[0];
            }
            $currentanswer = $qa->get_last_qt_var('answer_0');
            $inputname =  $inputname = $qa->get_qt_field_name('answer_0');
            $answertype = get_string('answer', 'qtype_abstraktne')." ".$this->get_textarea_tag(50, 10, $class, $inputname, $readonly, $currentanswer);
            
           
        }
        $nameprefix = $qa->get_qt_field_name('answer_');
    
        
        
        $result .="<div id=\"checker\" style=\"width: 160px;\"><button type=\"button\" onclick=\"checkCode('$nameprefix',$count)\">Kontrola syntaxe</button><div id=\"".$nameprefix."checker_c\" style=\"float: right;\"></div></div>";
        $result .= $answertype;
        $machine_config = addslashes(htmlspecialchars($question->hod_data));
              
      
        
       
        if ($qa->get_state() == question_state::$invalid) {
            $result .= html_writer::nonempty_tag('div',
                    $question->get_validation_error(array('answer' => $currentanswer)),
                    array('class' => 'validationerror'));
        }
        
        
        $result .= "<input type=\"hidden\" id=\"www_root\" name=\"www_adr\" value=\"$CFG->wwwroot\" />";
        $result .= "<input type=\"hidden\" id=\"dir_root\" name=\"dir_adr\" value=\"".str_replace('\\','/',$CFG->dirroot)."\" />"; 
        $result .= "<input type=\"hidden\" id=\"".$nameprefix."machine_config\" name=\"machine_config\" value=\"$machine_config\" />";
        
        
        return $result;
    }
    
    function check_answer_format_count($text)
    {
        $a = substr_count($text,"<answer>");
        $b = substr_count($text,"</answer>");
        if ($a == $b)
        {
            return true;
        }
        return false;
    }
    
    function get_inputtext_tag($size, $class, $nameprefix, $readonlyopt, $seqn, $value) {
        return "<input type=\"text\" class=\"$class\" name=$nameprefix id=$nameprefix $readonlyopt size=\"$size\" maxlength=\"$size\" value=\"$value\"/>";
    }
    
    function get_textarea_tag($cols, $rows, $class, $nameprefix, $readonly, $value)
    {
        return "<textarea class=\"$class\" $readonly name=$nameprefix cols=$cols rows=$rows id=\"$nameprefix\">$value</textarea>";
    }
    
    
    public function specific_feedback(question_attempt $qa) {
        return '';
    }

    public function correct_response(question_attempt $qa) {
        return '';
    }
}
